/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.battle.GAddShowBattleLoser
 *  fire.msp.battle.GRemoveMonstershow
 *  fire.pb.GsClient
 *  fire.pb.npc.SMonstershowConfig
 *  fire.pb.util.Misc
 *  fire.script.ParseStringExpression
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.Fighter
 */
package fire.pb.battle;

import fire.msp.battle.GAddShowBattleLoser;
import fire.msp.battle.GRemoveMonstershow;
import fire.pb.GsClient;
import fire.pb.battle.BasicEndHandler;
import fire.pb.battle.BattleConfigManager;
import fire.pb.battle.BattleEndHandler;
import fire.pb.battle.Module;
import fire.pb.battle.Monster;
import fire.pb.battle.PNewBattle;
import fire.pb.npc.SMonstershowConfig;
import fire.pb.util.Misc;
import fire.script.ParseStringExpression;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.script.ScriptException;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xbean.Fighter;

public class ShowBattle {
    private final SMonstershowConfig conf;
    private static ParseStringExpression pse = new ParseStringExpression();
    private static Map<String, Object> pseParas = new HashMap<String, Object>();
    private static Logger logger = Logger.getLogger((String)"BATTLE");
    private final long monsterid;
    private final int areaconf;
    private boolean isBossBattle;
    private final long roleID;
    private final int teamsize;

    public ShowBattle(long roleID, int teamsize, long monsterid, int monsterbaseid, int areaconf) {
        this.roleID = roleID;
        this.teamsize = teamsize;
        this.monsterid = monsterid;
        this.conf = Module.getInstance().getMonstershowConfigManager().getConfig(monsterbaseid);
        if (this.conf == null) {
            throw new NullPointerException("明雷怪baseid=" + monsterbaseid + "的配置为空,请检查配置表");
        }
        this.areaconf = areaconf;
    }

    public int getMonsterNum() {
        return Misc.getRandomBetween((int)this.teamsize, (int)(25 * (this.teamsize + 1) / 14));
    }

    public void launch() {
        List<Monster> monsters = this.getMonsters();
        if (monsters.size() != 0) {
            if (this.isBossBattle) {
                return;
            }
            PNewBattle batproc = new PNewBattle(this.roleID, monsters, (BattleEndHandler)new ShowBattleEndHandler());
            batproc.setAreaType(2);
            batproc.setAreaConf(this.areaconf);
            batproc.setBattleType(1200);
            batproc.setMonsterNpckey(this.monsterid);
            batproc.submit();
        }
    }

    private List<Monster> getMonsters() {
        ArrayList<Monster> monsters = new ArrayList<Monster>();
        BattleConfigManager.MonsterNumConfig monsternumConf = Module.getInstance().getBattleConfigManager().getMonsterNumConfig(this.teamsize);
        if (monsternumConf != null) {
            int s;
            monsters.add(new Monster(this.conf.指定怪id));
            int hasGen = 1;
            int random = Misc.getRandomBetween((int)1, (int)10000);
            int babyRate = this.calBattleTypeRate(this.conf.宝宝战斗概率);
            int bossRate = this.calBattleTypeRate(this.conf.BOSS战斗概率);
            if (random <= babyRate) {
                monsters.add(new Monster(this.getRandomPet()));
                ++hasGen;
            } else if (random <= bossRate + babyRate) {
                this.isBossBattle = true;
                int bossbattleid = this.conf.getBossbattleid();
                PNewBattle batproc = new PNewBattle(this.roleID, bossbattleid, (BattleEndHandler)new ShowBattleEndHandler());
                batproc.setAreaType(2);
                batproc.setAreaConf(this.areaconf);
                batproc.setMonsterType(2);
                batproc.setBattleType(30);
                batproc.setMonsterNpckey(this.monsterid);
                batproc.submit();
                return monsters;
            }
            for (int i = hasGen; i < monsternumConf.getNormalnum(); ++i) {
                monsters.add(new Monster(this.getRandomMonster()));
            }
            for (int i = s = (t = hasGen - monsternumConf.getNormalnum()) > 0 ? t : 0; i < monsternumConf.getHeadnum(); ++i) {
                monsters.add(new Monster(this.getRandomHeadMonster()));
            }
        }
        return monsters;
    }

    private int calBattleTypeRate(String commonrate) {
        pseParas.put("TeamNum", this.teamsize);
        int rate = 0;
        try {
            Double value = pse.ParseStr(commonrate, pseParas);
            rate = value.intValue();
            return rate;
        }
        catch (ScriptException e) {
            logger.error((Object)("error when parsing battleTypeRate String:" + commonrate), (Throwable)e);
            return 0;
        }
    }

    private int getRandomPet() {
        int totalprob = 0;
        for (Integer prob : this.conf.宝宝概率) {
            totalprob += prob.intValue();
        }
        if (totalprob != 1000) {
            throw new RuntimeException(this.conf.id + ": 宝宝总概率不为1000");
        }
        int random = Misc.getRandomBetween((int)1, (int)1000);
        for (int i = 0; i < this.conf.宝宝概率.size(); ++i) {
            int prob = (Integer)this.conf.宝宝概率.get(i);
            if (random <= prob) {
                return (Integer)this.conf.宝宝.get(i);
            }
            random -= prob;
        }
        throw new RuntimeException("获得明雷怪boss id的时候出错");
    }

    private int getRandomMonster() {
        if (this.conf.怪物概率 == null || this.conf.怪物概率.isEmpty()) {
            throw new RuntimeException("获得明雷怪普通战斗怪物id的时候出错");
        }
        int totalprob = 0;
        for (Integer prob : this.conf.怪物概率) {
            totalprob += prob.intValue();
        }
        if (totalprob != 1000) {
            throw new RuntimeException(this.conf.id + ": 怪物总概率不为1000");
        }
        int random = Misc.getRandomBetween((int)1, (int)1000);
        for (int i = 0; i < this.conf.怪物概率.size(); ++i) {
            int prob = (Integer)this.conf.怪物概率.get(i);
            if (random <= prob) {
                return (Integer)this.conf.怪物.get(i);
            }
            random -= prob;
        }
        throw new RuntimeException("获得明雷怪普通战斗怪物id的时候出错");
    }

    private int getRandomHeadMonster() {
        if (this.conf.精英概率 == null || this.conf.精英概率.isEmpty()) {
            return this.getRandomMonster();
        }
        int totalprob = 0;
        for (Integer prob : this.conf.精英概率) {
            totalprob += prob.intValue();
        }
        if (totalprob != 1000) {
            throw new RuntimeException(this.conf.id + ": 头领总概率不为1000");
        }
        int random = Misc.getRandomBetween((int)1, (int)1000);
        for (int i = 0; i < this.conf.精英概率.size(); ++i) {
            int prob = (Integer)this.conf.精英概率.get(i);
            if (random <= prob) {
                return (Integer)this.conf.精英.get(i);
            }
            random -= prob;
        }
        throw new RuntimeException("获得明雷怪boss id的时候出错");
    }

    private static final class ShowBattleEndHandler
    extends BasicEndHandler {
        private ShowBattleEndHandler() {
        }

        @Override
        public boolean handleOutBattle(int index, int petkey) throws Exception {
            Fighter f = (Fighter)this.battle.getFighters().get(index);
            if (f == null) {
                return true;
            }
            if (f.getFightertype() == 1) {
                GAddShowBattleLoser addloser = new GAddShowBattleLoser();
                addloser.npckey = this.battle.getMonsterid();
                addloser.losers.add(f.getUniqueid());
                GsClient.pSendWhileCommit((Protocol)addloser);
            }
            return super.handleOutBattle(index, petkey);
        }

        @Override
        public boolean handleAward() {
            GRemoveMonstershow send = new GRemoveMonstershow();
            send.monsterkey = this.battle.getMonsterid();
            GsClient.sendToScene((Protocol)send);
            return super.handleAward();
        }

        @Override
        protected boolean handleBattleFailed() {
            GAddShowBattleLoser addloser = new GAddShowBattleLoser();
            addloser.npckey = this.battle.getMonsterid();
            addloser.losers.addAll(this.battle.getRoleids().keySet());
            GsClient.pSendWhileCommit((Protocol)addloser);
            return super.handleBattleFailed();
        }

        @Override
        protected boolean handleDrawBattle() {
            GAddShowBattleLoser addloser = new GAddShowBattleLoser();
            addloser.npckey = this.battle.getMonsterid();
            addloser.losers.addAll(this.battle.getRoleids().keySet());
            GsClient.pSendWhileCommit((Protocol)addloser);
            return super.handleDrawBattle();
        }
    }
}

